#include "stdafx.h"
#include "Emu/System.h"
#include "Emu/PSP2/ARMv7Module.h"

#include "sceLibXml.h"

logs::channel sceLibXml("sceLibXml", logs::level::notice);

#define REG_FUNC(nid, name) REG_FNID(SceLibXml, nid, name)

DECLARE(arm_module_manager::SceLibXml)("SceLibXml", []()
{
	//REG_FUNC(0x57400A1A, _ZN3sce3Xml10SimpleDataC1EPKcj);
	//REG_FUNC(0x7E582075, _ZN3sce3Xml10SimpleDataC1Ev);
	//REG_FUNC(0x4CF0656B, _ZN3sce3Xml10SimpleDataC2EPKcj);
	//REG_FUNC(0x95077028, _ZN3sce3Xml10SimpleDataC2Ev);
	//REG_FUNC(0xECFA6A2A, _ZN3sce3Xml11Initializer10initializeEPKNS0_13InitParameterE);
	//REG_FUNC(0x29824CD5, _ZN3sce3Xml11Initializer9terminateEv);
	//REG_FUNC(0xBF13FDE6, _ZN3sce3Xml11InitializerC1Ev);
	//REG_FUNC(0x94AAA71D, _ZN3sce3Xml11InitializerC2Ev);
	//REG_FUNC(0xB4547C88, _ZN3sce3Xml11InitializerD1Ev);
	//REG_FUNC(0xAAA08FA8, _ZN3sce3Xml11InitializerD2Ev);
	//REG_FUNC(0x8D387E01, _ZN3sce3Xml12MemAllocatorC1Ev);
	//REG_FUNC(0xE982E681, _ZN3sce3Xml12MemAllocatorC2Ev);
	//REG_FUNC(0x90B82579, _ZN3sce3Xml12MemAllocatorD0Ev);
	//REG_FUNC(0x56002B9D, _ZN3sce3Xml12MemAllocatorD1Ev);
	//REG_FUNC(0x1BE022EA, _ZN3sce3Xml12MemAllocatorD2Ev);
	//REG_FUNC(0x89AA847E, _ZN3sce3Xml13AttributeList10initializeEPKNS0_11InitializerE);
	//REG_FUNC(0xD08EE434, _ZN3sce3Xml13AttributeList12addAttributeEPKNS0_6StringES4_);
	//REG_FUNC(0xCCEE4E7C, _ZN3sce3Xml13AttributeList5clearEv);
	//REG_FUNC(0x11FE5A65, _ZN3sce3Xml13AttributeList9terminateEv);
	//REG_FUNC(0x9CBD82D4, _ZN3sce3Xml13AttributeListC1ERKS1_);
	//REG_FUNC(0x542076D8, _ZN3sce3Xml13AttributeListC1Ev);
	//REG_FUNC(0x87C89447, _ZN3sce3Xml13AttributeListC2ERKS1_);
	//REG_FUNC(0x5D49542A, _ZN3sce3Xml13AttributeListC2Ev);
	//REG_FUNC(0x38861841, _ZN3sce3Xml13AttributeListD1Ev);
	//REG_FUNC(0x1B0B3976, _ZN3sce3Xml13AttributeListD2Ev);
	//REG_FUNC(0x30520B78, _ZN3sce3Xml14VarAllocBuffer4copyEPKhjb);
	//REG_FUNC(0x7D5A0041, _ZN3sce3Xml14VarAllocBuffer5clearEv);
	//REG_FUNC(0xD95D3824, _ZN3sce3Xml14VarAllocBuffer7copyStrEPKcj);
	//REG_FUNC(0xFE99676E, _ZN3sce3Xml14VarAllocBuffer7copyStrERKNS0_6StringE);
	//REG_FUNC(0x82747F92, _ZN3sce3Xml14VarAllocBuffer7reserveEj);
	//REG_FUNC(0xE93EACFC, _ZN3sce3Xml14VarAllocBuffer9terminateEv);
	//REG_FUNC(0x8045D9C2, _ZN3sce3Xml14VarAllocBufferC1EPKNS0_11InitializerE);
	//REG_FUNC(0xEF4FA027, _ZN3sce3Xml14VarAllocBufferC2EPKNS0_11InitializerE);
	//REG_FUNC(0xD61CAAFC, _ZN3sce3Xml14VarAllocBufferD0Ev);
	//REG_FUNC(0xD9217FC8, _ZN3sce3Xml14VarAllocBufferD1Ev);
	//REG_FUNC(0x8A4B9379, _ZN3sce3Xml14VarAllocBufferD2Ev);
	//REG_FUNC(0xB7770E5E, _ZN3sce3Xml18SerializeParameterC1Ev);
	//REG_FUNC(0xF65270FC, _ZN3sce3Xml18SerializeParameterC2Ev);
	//REG_FUNC(0x2CB61A7C, _ZN3sce3Xml20bXResultToResultTypeEi);
	//REG_FUNC(0x59C5E9B2, _ZN3sce3Xml23getMemManagerDebugLevelEv);
	//REG_FUNC(0xBA8B7374, _ZN3sce3Xml23setMemManagerDebugLevelEi);
	//REG_FUNC(0xBBACFE87, _ZN3sce3Xml3Dom15DocumentBuilder10initializeEPKNS0_11InitializerE);
	//REG_FUNC(0x1A29526B, _ZN3sce3Xml3Dom15DocumentBuilder11getDocumentEv);
	//REG_FUNC(0xA2431C2B, _ZN3sce3Xml3Dom15DocumentBuilder16setResolveEntityEb);
	//REG_FUNC(0xB8C4D13C, _ZN3sce3Xml3Dom15DocumentBuilder20setSkipIgnorableTextEb);
	//REG_FUNC(0xF351D753, _ZN3sce3Xml3Dom15DocumentBuilder26setSkipIgnorableWhiteSpaceEb);
	//REG_FUNC(0x7744DD14, _ZN3sce3Xml3Dom15DocumentBuilder5parseEPKNS0_6StringEb);
	//REG_FUNC(0x42D59053, _ZN3sce3Xml3Dom15DocumentBuilder9terminateEv);
	//REG_FUNC(0x702492EA, _ZN3sce3Xml3Dom15DocumentBuilderC1Ev);
	//REG_FUNC(0x36F6BDF2, _ZN3sce3Xml3Dom15DocumentBuilderC2Ev);
	//REG_FUNC(0x79C9322E, _ZN3sce3Xml3Dom15DocumentBuilderD0Ev);
	//REG_FUNC(0x19D0E024, _ZN3sce3Xml3Dom15DocumentBuilderD1Ev);
	//REG_FUNC(0x99C58389, _ZN3sce3Xml3Dom15DocumentBuilderD2Ev);
	//REG_FUNC(0x3CA958D3, _ZN3sce3Xml3Dom4Node11removeChildEy);
	//REG_FUNC(0x1B98BDBE, _ZN3sce3Xml3Dom4Node12insertBeforeEyy);
	//REG_FUNC(0x26BA1E6E, _ZNK3sce3Xml3Dom4Node13hasAttributesEv);
	//REG_FUNC(0xC6F4F6A8, _ZN3sce3Xml3Dom4Node13hasChildNodesEv);
	//REG_FUNC(0x088C100E, _ZN3sce3Xml3Dom4NodeC1Ey);
	//REG_FUNC(0x44CAF9E1, _ZN3sce3Xml3Dom4NodeC2Ey);
	//REG_FUNC(0x8F2EB967, _ZN3sce3Xml3Dom4NodeD1Ev);
	//REG_FUNC(0x241EFC0E, _ZN3sce3Xml3Dom4NodeD2Ev);
	//REG_FUNC(0x6A16C2FF, _ZN3sce3Xml3Dom8Document10importNodeEyyPKS2_y);
	//REG_FUNC(0xB4A33B78, _ZN3sce3Xml3Dom8Document10initializeEPKNS0_11InitializerE);
	//REG_FUNC(0x18686B94, _ZN3sce3Xml3Dom8Document10insertNodeEyyy);
	//REG_FUNC(0x49263CE5, _ZN3sce3Xml3Dom8Document11removeChildEyy);
	//REG_FUNC(0xD945184A, _ZN3sce3Xml3Dom8Document11resetStatusEv);
	//REG_FUNC(0x7B0A8F6C, _ZN3sce3Xml3Dom8Document11setWritableEv);
	//REG_FUNC(0x0CBC1C3F, _ZN3sce3Xml3Dom8Document12importParentEPKS2_y);
	//REG_FUNC(0x016A9ADB, _ZN3sce3Xml3Dom8Document12setAttrValueEyPKNS0_6StringES5_);
	//REG_FUNC(0xEA19C7CF, _ZN3sce3Xml3Dom8Document12setAttributeEyPKNS0_6StringES5_);
	//REG_FUNC(0x35C50B8B, _ZN3sce3Xml3Dom8Document13createElementEPKNS0_6StringEPKNS0_13AttributeListES5_);
	//REG_FUNC(0xBCA5E62A, _ZN3sce3Xml3Dom8Document13recurseDeleteEy);
	//REG_FUNC(0x8D19723F, _ZN3sce3Xml3Dom8Document14createTextNodeEPKNS0_6StringE);
	//REG_FUNC(0x6220E98B, _ZN3sce3Xml3Dom8Document15addElementChildEyPKNS0_6StringEPKNS0_13AttributeListES5_);
	//REG_FUNC(0xF1DB18B1, _ZN3sce3Xml3Dom8Document15removeAttributeEyPKNS0_6StringE);
	//REG_FUNC(0x779036AB, _ZN3sce3Xml3Dom8Document16removeAttributesEy);
	//REG_FUNC(0x0667B08D, _ZN3sce3Xml3Dom8Document16setAttributeListEyPKNS0_13AttributeListE);
	//REG_FUNC(0xD2BFBC47, _ZNK3sce3Xml3Dom8Document20getElementsByTagNameEyPKNS0_6StringEPNS1_8NodeListE);
	//REG_FUNC(0xDEFEAFD2, _ZN3sce3Xml3Dom8Document7setTextEyPKNS0_6StringE);
	//REG_FUNC(0x87F8B4DA, _ZN3sce3Xml3Dom8Document9serializeEPKNS0_18SerializeParameterEPNS0_6StringE);
	//REG_FUNC(0x4B7321FB, _ZN3sce3Xml3Dom8Document9terminateEv);
	//REG_FUNC(0x1DD41C7A, _ZN3sce3Xml3Dom8DocumentC1ERKS2_);
	//REG_FUNC(0x7B7107AD, _ZN3sce3Xml3Dom8DocumentC1Ev);
	//REG_FUNC(0xF399F763, _ZN3sce3Xml3Dom8DocumentC2ERKS2_);
	//REG_FUNC(0xE6BA9C73, _ZN3sce3Xml3Dom8DocumentC2Ev);
	//REG_FUNC(0xFB207925, _ZN3sce3Xml3Dom8DocumentD1Ev);
	//REG_FUNC(0x11A5F0A3, _ZN3sce3Xml3Dom8DocumentD2Ev);
	//REG_FUNC(0xD622A7FE, _ZN3sce3Xml3Dom8DocumentaSERKS2_);
	//REG_FUNC(0x860CC706, _ZN3sce3Xml3Dom8NodeList10initializeEPKNS0_11InitializerE);
	//REG_FUNC(0x7A889374, _ZN3sce3Xml3Dom8NodeList10insertLastEy);
	//REG_FUNC(0xE9995F58, _ZN3sce3Xml3Dom8NodeList10removeItemEy);
	//REG_FUNC(0xFA921C6E, _ZN3sce3Xml3Dom8NodeList11insertFirstEy);
	//REG_FUNC(0xCDD1D418, _ZNK3sce3Xml3Dom8NodeList4itemEj);
	//REG_FUNC(0x508E9150, _ZN3sce3Xml3Dom8NodeList5clearEv);
	//REG_FUNC(0xA41ED241, _ZNK3sce3Xml3Dom8NodeList8findItemEPKNS0_6StringE);
	//REG_FUNC(0xE1AB441D, _ZNK3sce3Xml3Dom8NodeList8findItemEy);
	//REG_FUNC(0xFB9EDBF9, _ZNK3sce3Xml3Dom8NodeList9getLengthEv);
	//REG_FUNC(0x32B396AD, _ZN3sce3Xml3Dom8NodeList9terminateEv);
	//REG_FUNC(0xB1CA0E34, _ZN3sce3Xml3Dom8NodeListC1ERKS2_);
	//REG_FUNC(0x0580C02E, _ZN3sce3Xml3Dom8NodeListC1Ev);
	//REG_FUNC(0xB97BF737, _ZN3sce3Xml3Dom8NodeListC2ERKS2_);
	//REG_FUNC(0x684E57B9, _ZN3sce3Xml3Dom8NodeListC2Ev);
	//REG_FUNC(0x92EBC9F8, _ZN3sce3Xml3Dom8NodeListD1Ev);
	//REG_FUNC(0x2DF80037, _ZN3sce3Xml3Dom8NodeListD2Ev);
	//REG_FUNC(0xBAD4AAFA, _ZNK3sce3Xml3Dom8NodeListixEj);
	//REG_FUNC(0x874C8331, _ZN3sce3Xml3Sax6Parser10initializeEPKNS0_11InitializerE);
	//REG_FUNC(0x4DB998E6, _ZN3sce3Xml3Sax6Parser11setUserDataEPv);
	//REG_FUNC(0xB77BF8A0, _ZN3sce3Xml3Sax6Parser16setResolveEntityEb);
	//REG_FUNC(0x1B2442A0, _ZN3sce3Xml3Sax6Parser18setDocumentHandlerEPNS1_15DocumentHandlerE);
	//REG_FUNC(0xCE1DAE23, _ZN3sce3Xml3Sax6Parser26setSkipIgnorableWhiteSpaceEb);
	//REG_FUNC(0x70D9FC8E, _ZN3sce3Xml3Sax6Parser5parseEPKNS0_6StringEb);
	//REG_FUNC(0xA2B40FA7, _ZN3sce3Xml3Sax6Parser5resetEv);
	//REG_FUNC(0xF2C8950D, _ZN3sce3Xml3Sax6Parser9terminateEv);
	//REG_FUNC(0x60BF9988, _ZN3sce3Xml3Sax6ParserC1Ev);
	//REG_FUNC(0x56390CA0, _ZN3sce3Xml3Sax6ParserC2Ev);
	//REG_FUNC(0xA11C2AED, _ZN3sce3Xml3Sax6ParserD1Ev);
	//REG_FUNC(0x02E8F7FA, _ZN3sce3Xml3Sax6ParserD2Ev);
	//REG_FUNC(0xE5314387, _ZN3sce3Xml4Attr10initializeEPKNS0_11InitializerE);
	//REG_FUNC(0x66D1B605, _ZN3sce3Xml4Attr7setNameEPKNS0_6StringE);
	//REG_FUNC(0x7DD3059D, _ZN3sce3Xml4Attr8setValueEPKNS0_6StringE);
	//REG_FUNC(0x67E0DF2B, _ZN3sce3Xml4Attr9terminateEv);
	//REG_FUNC(0xC09ABF87, _ZN3sce3Xml4AttrC1ERKS1_);
	//REG_FUNC(0xD016F1BC, _ZN3sce3Xml4AttrC1Ev);
	//REG_FUNC(0xB4851BEC, _ZN3sce3Xml4AttrC2ERKS1_);
	//REG_FUNC(0x0B3AE81B, _ZN3sce3Xml4AttrC2Ev);
	//REG_FUNC(0x58E349A5, _ZN3sce3Xml4AttrD1Ev);
	//REG_FUNC(0xB9E6F81A, _ZN3sce3Xml4AttrD2Ev);
	//REG_FUNC(0xA5B902D4, _ZN3sce3Xml4AttraSERKS1_);
	//REG_FUNC(0xA7E983E2, _ZN3sce3Xml4Util9strResultEi);
	//REG_FUNC(0x035F013B, _ZN3sce3Xml6StringC1EPKc);
	//REG_FUNC(0x0B5461E0, _ZN3sce3Xml6StringC1EPKcj);
	//REG_FUNC(0x67191CC6, _ZN3sce3Xml6StringC1ERKS1_);
	//REG_FUNC(0xA17502C1, _ZN3sce3Xml6StringC1Ev);
	//REG_FUNC(0xECC1F1A4, _ZN3sce3Xml6StringC2EPKc);
	//REG_FUNC(0x457CCE55, _ZN3sce3Xml6StringC2EPKcj);
	//REG_FUNC(0xD785BA85, _ZN3sce3Xml6StringC2ERKS1_);
	//REG_FUNC(0x8816F7EF, _ZN3sce3Xml6StringC2Ev);
	//REG_FUNC(0x18758863, _ZN3sce3Xml6StringaSERKS1_);
	//REG_FUNC(0x4F30F0CC, _ZNK3sce3Xml13AttributeList12getAttributeEPKNS0_6StringE);
	//REG_FUNC(0x5ED0B2F9, _ZNK3sce3Xml13AttributeList12getAttributeEj);
	//REG_FUNC(0x38AEB52E, _ZNK3sce3Xml13AttributeList9getLengthEv);
	//REG_FUNC(0xEC96BFC6, _ZNK3sce3Xml3Dom13DocumentDebug13getStructSizeEv);
	//REG_FUNC(0xE1100FC0, _ZNK3sce3Xml3Dom13DocumentDebug16getAttrTableSizeEv);
	//REG_FUNC(0x6E1F1FFB, _ZNK3sce3Xml3Dom13DocumentDebug16getCharTableSizeEv);
	//REG_FUNC(0x8F9CEE10, _ZNK3sce3Xml3Dom13DocumentDebug19getElementTableSizeEv);
	//REG_FUNC(0xE1269956, _ZNK3sce3Xml3Dom4Node11getNodeNameEv);
	//REG_FUNC(0xCED5E0FF, _ZNK3sce3Xml3Dom4Node11getNodeTypeEv);
	//REG_FUNC(0x4F2D5541, _ZNK3sce3Xml3Dom4Node12getNodeValueEv);
	//REG_FUNC(0xB405A149, _ZNK3sce3Xml3Dom4Node13getAttributesEv);
	//REG_FUNC(0x117BEA8A, _ZNK3sce3Xml3Dom4Node13getChildNodesEv);
	//REG_FUNC(0x639D219C, _ZNK3sce3Xml3Dom4Node13getFirstChildEv);
	//REG_FUNC(0x3FD63FB8, _ZNK3sce3Xml3Dom4Node12getLastChildEv);
	//REG_FUNC(0x1A46C0E1, _ZNK3sce3Xml3Dom4Node14getNextSiblingEv);
	//REG_FUNC(0xD9757BC8, _ZNK3sce3Xml3Dom4Node14getParenetNodeEv);
	//REG_FUNC(0x3E8122AB, _ZNK3sce3Xml3Dom4Node16getOwnerDocumentEv);
	//REG_FUNC(0x22DBB221, _ZNK3sce3Xml3Dom8Document10getDocRootEv);
	//REG_FUNC(0xE3D0A78A, _ZNK3sce3Xml3Dom8Document10getSiblingEy);
	//REG_FUNC(0x2D370226, _ZNK3sce3Xml3Dom8Document10getXmlMetaEv);
	//REG_FUNC(0xA4D99D40, _ZNK3sce3Xml3Dom8Document10isReadOnlyEv);
	//REG_FUNC(0xCD65B91F, _ZNK3sce3Xml3Dom8Document11getAttrNameEy);
	//REG_FUNC(0x883E1BFC, _ZNK3sce3Xml3Dom8Document11getNextAttrEy);
	//REG_FUNC(0x471A22E8, _ZNK3sce3Xml3Dom8Document11getNodeNameEy);
	//REG_FUNC(0x62D3CB44, _ZNK3sce3Xml3Dom8Document11getNodeTypeEy);
	//REG_FUNC(0x28FD79E3, _ZNK3sce3Xml3Dom8Document11isAvailableEv);
	//REG_FUNC(0x7C6A03FD, _ZNK3sce3Xml3Dom8Document12getAttrValueEy);
	//REG_FUNC(0x9531C3CD, _ZNK3sce3Xml3Dom8Document12getAttributeEyPKNS0_6StringE);
	//REG_FUNC(0xEC856072, _ZNK3sce3Xml3Dom8Document12getFirstAttrEy);
	//REG_FUNC(0xFBCF0D3E, _ZNK3sce3Xml3Dom8Document12getLastChildEy);
	//REG_FUNC(0xCDEC3F43, _ZNK3sce3Xml3Dom8Document13getAttributesEyPNS1_8NodeListE);
	//REG_FUNC(0xFC61FDF1, _ZNK3sce3Xml3Dom8Document13getChildNodesEyPNS1_8NodeListE);
	//REG_FUNC(0xDAC75E49, _ZNK3sce3Xml3Dom8Document13getEntityTypeEy);
	//REG_FUNC(0xEA805296, _ZNK3sce3Xml3Dom8Document13hasAttributesEy);
	//REG_FUNC(0xC5E7431A, _ZNK3sce3Xml3Dom8Document13hasChildNodesEy);
	//REG_FUNC(0x0C1DDEC5, _ZNK3sce3Xml3Dom8Document14getSkippedTextEy);
	//REG_FUNC(0xB34D9672, _ZNK3sce3Xml3Dom8Document7getRootEv);
	//REG_FUNC(0x36ACFF5E, _ZNK3sce3Xml3Dom8Document7getTextEy);
	//REG_FUNC(0x3028E05D, _ZNK3sce3Xml3Dom8Document13getFirstChildEy);
	//REG_FUNC(0x161BA85E, _ZNK3sce3Xml3Dom8Document9getEntityEy);
	//REG_FUNC(0xA98B5758, _ZNK3sce3Xml3Dom8Document9getParentEy);
	//REG_FUNC(0xD428753A, _ZNK3sce3Xml3Dom8Document9getStatusEv);
	//REG_FUNC(0x10530611, _ZNK3sce3Xml3Dom8NodeList11isAvailableEv);
	//REG_FUNC(0x35134B85, _ZNK3sce3Xml4Attr7getNameEv);
	//REG_FUNC(0x7834A2F7, _ZNK3sce3Xml4Attr8getValueEv);
	//REG_FUNC(0x0D119AB3, _ZNK3sce3Xml3Dom4Node11isAvailableEv);
	//REG_FUNC(0x1633846D, _ZNK3sce3Xml4Attr11isAvailableEv);
	//REG_FUNC(0x58854322, _ZNK3sce3Xml13AttributeList11isAvailableEv);
});
